#include <SDL.h>
#include <list>
#include "ResourceManager/resManager.h"
#include "Eventhandler.h"
#include "Gamestate.h"

#include "global.h"
#include "Map.h"
#include "GameObject.h"
#include "GameObjectList.h"
#include "GamestateStartup.h"

#include "Light.h"
#include "Ghost.h"
#include "Candle.h"



//---------------------------------------------------------------------------------------------------
Candle :: Candle(float nx, float ny) : GameObject(nx, ny, resmanager->getProperties("data/objects/candle.xml"), OBJ_CANDLE),
											wobbl(0.020f, 4.3f, -0.4f, 0.3f){
	imgCandle			= resmanager->getImage("data/images/candle/candle.png");
	imgLight			= resmanager->getImage("data/images/candle/candle_light.png");
	imgLightWhite		= resmanager->getImage("data/images/candle/candle_light2.png");

	lightlist->add(this);

	this->collidesWithMap			= false;
	this->affectedByGravitation		= false;
}


void Candle :: think(){
	wobbl.update();
}


const float lightwobblfactor = 0.2f;
const float lightscalefactor = 0.005f;

void Candle :: draw(){
	imgCandle->draw(UIImage::NORMAL, UIImage::TRANSFORM | UIImage::CENTER, x, y);
//	imgLightWhite->setScale(1.0f + wobbl.getX()*lightscalefactor);
	//imgLightWhite->draw(UIImage::NORMAL, UIImage::TRANSFORM | UIImage::CENTER | UIImage::SCALE, x+ wobbl.getX()*lightwobblfactor, y+ wobbl.getY()*lightwobblfactor);
}

void Candle :: drawLight(){
	imgLight->setScale(1.0f + wobbl.getX()*lightscalefactor);
	imgLight->draw(UIImage::NORMAL, UIImage::TRANSFORM | UIImage::CENTER  |UIImage::SCALE, x+ wobbl.getX()*lightwobblfactor, y+ wobbl.getY()*lightwobblfactor);
}