

#include <SDL.h>
#include <stdio.h>
#include <list>

#include "Eventhandler.h"

//main.cpp

EventhandlerManager * _currentEventhandlerManager = NULL;

EventhandlerManager :: EventhandlerManager(){
	_currentEventhandlerManager = this;
}

void EventhandlerManager :: addEventhandler(Eventhandler *handler, Uint8 eventtype){
    eventLists[eventtype].push_back(handler);
}  


void EventhandlerManager :: removeEventhandler(Eventhandler *handler){
    for(int i=0; i<SDL_NUMEVENTS; i++){
        eventLists[i].remove(handler);
    }    
}


void EventhandlerManager :: callEventhandler(SDL_Event &e){
    std::list<Eventhandler *>::iterator it = eventLists[e.type].begin();   
    
    while(it != eventLists[e.type].end()){   
		//printf("                           call eventhandler %p\n", (*it));
        (*it)->handleEvent(e);       
        it++;
    }    
}

int EventhandlerManager :: countAllEventhandler(){
	int count = 0;
	for(int i = 0; i<SDL_NUMEVENTS; i++){
		std::list<Eventhandler *>::iterator it = eventLists[i].begin();   
    
		while(it != eventLists[i].end()){
			count++;
			it++;
		}
	}

	return count;
}




//Eventhandler ----------------------------------------------------------------------


void Eventhandler :: registerForEvent(Uint8 eventType){
	EventhandlerManager::getInstance() -> addEventhandler(this, eventType);    
}

    
void Eventhandler :: unregisterForAllEvents(){
	//printf("Event :: unregisterForAllEvents: %p\n", this);
    EventhandlerManager::getInstance() -> removeEventhandler(this);
}


Eventhandler :: ~Eventhandler(){
	//printf("Eventhandler :: ~Eventhanlder %p\n", this);
    unregisterForAllEvents();
}
    
