
#pragma once

extern class EventhandlerManager * _currentEventhandlerManager;  //I just don't get it...

class Eventhandler{
    public:
        virtual void handleEvent(SDL_Event &event) = 0;
        
        virtual ~Eventhandler(); //unregister at destruction!

    protected:
        void registerForEvent(Uint8 eventType);
        void unregisterForAllEvents();
};    


class EventhandlerManager{
	public:
		EventhandlerManager();

		void addEventhandler(Eventhandler *handler, Uint8 eventtype);
		void removeEventhandler(Eventhandler *handler);
		void callEventhandler(SDL_Event &e);
		int countAllEventhandler();

		static EventhandlerManager *getInstance(){ return _currentEventhandlerManager;};

	private:
		std::list<Eventhandler *> eventLists[SDL_NUMEVENTS];
		//static EventhandlerManager * _currentEventhandlerManager;
};

