
#pragma once

enum EObjectType{
	OBJ_PLAYER = 0,
	OBJ_GHOST,
	OBJ_GHOSTCANDLE,
	OBJ_CANDLE,
	OBJ_GOLD,
	OBJ_SPIKES,

	OBJ_LAST
};


class GameObject{
	public:
		virtual void think()							  = 0;  //false: remove
		virtual void draw()								  = 0;
		virtual void collideWithMap(MapCol &col)		  = 0;
		virtual void pain(GameObject *other, int dmg)	  = 0;
		virtual void collideWithObject(GameObject *other) = 0;

		GameObject(float nx, float ny, Properties *nproperties, EObjectType ntype);
		virtual ~GameObject()								{;};

		float getX(){return x;};
		float getY(){return y;};
		float getTopLeftX(){return x-w/2;};
		float getTopLeftY(){return y-h;};
		float getVelx(){return velx;};
		float getVely(){return vely;};
		float getH(){return (float)h;};
		float getW(){return (float)w;};

		EObjectType getType(){return type; };
		bool removeMe(){return remove;};

	//TODO: map collisiondetection screwed up a lot
	public: //sorry
		EObjectType	type;			  //type of the object (->child class)
		Properties *properties;

		float		ox, oy;			  //old position - NEVER USE OR RELY ON IT!
		float		x, y;			  //position
		int			h, w;			  //size
		float		velx, vely;		  //speed
		bool		remove;

		bool		collidesWithMap;
		bool		affectedByGravitation;


	friend class GameObjectList;
	friend class Map;
	//friend bool coldec_obj2obj(GameObject &o1, GameObject &o2);
};

