#include <stdio.h>
#include <SDL.h>

#include "Gamestate.h"


GamestateManager * _currentManager = NULL;


GamestateManager :: GamestateManager(Gamestate *startGS){
	framestart		= SDL_GetTicks();
	_currentManager	= this;
	currentGS		= startGS;
		currentGS->start();
	newGS			= NULL;
	isQuitRequested	= false;
	
}


GamestateManager :: ~GamestateManager(){
	currentGS->stop();
	delete currentGS;
	_currentManager = NULL;
}


void GamestateManager :: queueGamestateSwitch(Gamestate *newgs, bool keepOld){
	if(this->newGS != NULL){
		printf("new gamestate alrady queued - WTF?\n");
	}
	else{
		this->newGS			= newgs;
		this->keepOld		= keepOld;
	}
}

void GamestateManager :: runCurrentGamestate(){
	int newframestart	= SDL_GetTicks();
	int duration		= (newframestart-framestart);
	fps					= duration == 0 ? 999.99f : (float)(1000/duration);
	framestart			= newframestart;

	if(newGS != NULL)
		switchGamestate();

	currentGS->run();
}

void GamestateManager :: switchGamestate(){
	Gamestate *old = currentGS;
	
	old->stop();
    newGS->start();
    currentGS = newGS;   
	
	if(!keepOld){
		//printf("  delete old gamestate: %p\n", old);
		delete old;
	}

	newGS = NULL; //done switching
}



//GAMESTATE------------------------------------------------------------------------------

void Gamestate :: queueGamestateSwitch(Gamestate *newgs, bool keepOld){
	GamestateManager::getInstance()->queueGamestateSwitch(newgs, keepOld);
}


void Gamestate :: quitGame(){
    GamestateManager::getInstance()->requestQuit();
}