#include <SDL.h>
#include <SDL_opengl.h>
#include <list>
#include "ResourceManager/resManager.h"
#include "Eventhandler.h"
#include "Gamestate.h"

#include "global.h"
#include "Map.h"
#include "GameObject.h"
#include "GameObjectList.h"
#include "GamestateStartup.h"

#include "Light.h"
#include "Ghost.h"
#include "Gold.h"



//---------------------------------------------------------------------------------------------------
const int plingmax = 5;
const int nextplingrand = 5000;
Gold :: Gold(float nx, float ny) : GameObject(nx, ny, resmanager->getProperties("data/objects/gold.xml"), OBJ_GOLD)
{
	imgGold				= resmanager->getImage("data/images/gold/gold.png");
	imgLight			= resmanager->getImage("data/images/gold/gold_light.png");

	lightlist->add(this);

	this->collidesWithMap			= false;
	this->affectedByGravitation		= false;

	plingcount = plingmax;
	nextpling = _currentManager->getFramestart();
}


void Gold :: think(){

	if(_currentManager->getFramestart() > nextpling){
		plingcount = plingmax;
		nextpling = _currentManager->getFramestart() + rand()%nextplingrand;
	}
}


void Gold :: draw(){
	
	glBlendFunc(GL_DST_COLOR, GL_SRC_ALPHA);
	imgGold->draw(UIImage::NORMAL, UIImage::TRANSFORM | UIImage::CENTER, x, y);
	imgGold->draw(UIImage::NORMAL, UIImage::TRANSFORM | UIImage::CENTER, x, y);
	if(plingcount > 0)
		imgLight->draw(UIImage::NORMAL, UIImage::TRANSFORM | UIImage::CENTER, x-20, y-30);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);	//the eyecandy is drawn as ususal
}

void Gold :: drawLight(){
	if(plingcount > 0){
		imgLight->draw(UIImage::NORMAL, UIImage::TRANSFORM | UIImage::CENTER, x-20, y-30);
		plingcount--;
	}
}