#include <stdio.h>
#include <SDL.h>
#include <SDL_opengl.h>

#include "ResourceManager/ResManager.h"

#include "global.h"
#include "Light.h"


LightList::LightList(){
	int i;

	for(i=0; i < MAX_LIGHT; i++)
		objlist[i] = NULL;
	objlist_last = 0;

	lightlist = this;
}


LightList::~LightList(){
	clear();
}


void LightList::clear(){
	int i;

	for(i=0; i < objlist_last; i++){
		if(objlist[i]){
			delete objlist[i];
		}
		objlist[i] = NULL;
	}
	objlist_last = 0;
}


bool LightList::add(Light *o){
	if(objlist_last < MAX_LIGHT){
		objlist[objlist_last]			= o;
		objlist_last++;

		return true;
	}
	else{
		delete o;					//otherwise memory leak!
		return false;
	}
}


void LightList::remove(int i){
	delete objlist[i];

	objlist_last--;
	if(i != objlist_last){	//if not the last object overwrite with last object
	    objlist[i] = objlist[objlist_last];
	}
}


void LightList::draw(){
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);		//draw lights (100% white)
	for(int i=0; i < objlist_last; i++){
		objlist[i]->drawLight();
	}
}