
#pragma once

#define ECol		int
#define	COL_NO		0x0
#define	COL_UP		0x1
#define	COL_DOWN	0x2
#define	COL_LEFT	0x4
#define	COL_RIGHT	0x8

struct MapCol{
	ECol		side;
	float		oldvelx;
	float		oldvely;
};

void coldec_obj2map(class GameObject &o);			//object-map collision detection - returns the directions in which tiles were hit


enum TileType{
	TT_NOTHING,
	TT_SOLID
};

class Map{
	public:
		Map(const char*);
		~Map();
		void draw(int scroll_x, int scroll_y);

		void limitScroll(int &scroll_x, int &scroll_y);

		int boundx(){return xmax;};
		int boundy(){return ymax;};

		TileType map(int x, int y){	return tiles2d[y][x];	}

	private:
		TileType *tiles;
		TileType **tiles2d;

		int width;
		int height;
		
		int		xmax;		//boundaries of the map in pixel
		int		ymax;

		UIImage *imgTile;
		UIImage *imgTileBlack;
};