#include <SDL.h>
#include <list>
#include "ResourceManager/resManager.h"
#include "Eventhandler.h"
#include "Gamestate.h"

#include "global.h"
#include "Map.h"
#include "GameObject.h"
#include "GameObjectList.h"
#include "GamestateStartup.h"

#include "Light.h"
#include "Ghost.h" //Wobbl
#include "Player.h"



Player :: Player(float nx, float ny): GameObject(nx, ny, resmanager->getProperties("data/objects/player.xml"), OBJ_PLAYER),
									  wobbl(0.02f, 2.6f, -0.3f, 0.4f){
	imgEyes = resmanager->getImage("data/images/player/eyes.png");
	imgTorso = resmanager->getImage("data/images/player/torso.png");

	this->registerForEvent(SDL_KEYDOWN);
	this->registerForEvent(SDL_KEYUP);

	actionJump		= false;
	actionRight		= false;
	actionLeft		= false;
	actionCrouch	= false;

	moving			= MOVE_NO;
}

void Player :: draw(){
	imgEyes->draw(x+wobbl.getX()/2, y+wobbl.getY()/2);
	imgTorso->draw(x, y);
}

void Player :: think(){
	wobbl.update();
	if(actionLeft)
		velx = -4.f;
	else if(actionRight)
		velx = 4.f;
	else
		velx = 0;
	if(actionJump)
		vely = -4.f;
}


void Player ::handleEvent(SDL_Event &e){
	if(e.type == SDL_KEYDOWN){
		switch(e.key.keysym.sym){
			case SDLK_UP:
				actionJump = true;
			break;
			case SDLK_DOWN:
				actionCrouch = true;
			break;
			case SDLK_RIGHT:
				actionRight = true;
			break;
			case SDLK_LEFT:
				actionLeft = true;
			break;
			default:
			break;
		}
	}					//^^ i know ,,
	else if(e.type == SDL_KEYUP){
		switch(e.key.keysym.sym){
			case SDLK_UP:
				actionJump = false;
			break;
			case SDLK_DOWN:
				actionCrouch = false;
			break;
			case SDLK_RIGHT:
				actionRight = false;
			break;
			case SDLK_LEFT:
				actionLeft = false;
			break;
			default:
			break;
		}
	}
}
