

#include <map>
#include <string>

#include "../turska/UI.h"
#include "../xml/Properties.h"
#include "ResManager.h"


UIImage *ResManager :: getImage(const std::string &filename){
    std::map<std::string, UIImage *> :: iterator iter = images.find(filename);
    
    if(iter != images.end()){    //loaded!
        return iter->second;
    }    
    else{								//not loaded -> load      
		UIImage * i = graphics->loadImage(filename.c_str());
		if(i == NULL)
			printf("error loading image %s.\n", filename.c_str());

        images[filename] = i;
        return i;
    }
}



Properties *ResManager :: getProperties(const std::string &filename){
    std::map<std::string, Properties *> :: iterator iter = properties.find(filename);
    
    if(iter != properties.end()){
        return iter->second;
    }        
    else{
        Properties *prop = new Properties(filename.c_str());
        properties[filename] = prop;
        return prop;
    }
}





//deletes the value, not the key.
#define _clear(_type, _name)							\
	{													\
														\
	std::map<std::string, _type> :: iterator tIter;		\
    tIter = _name.begin();								\
    while(tIter != _name.end()){						\
        delete tIter->second;							\
        ++tIter;										\
    }													\
    }													


ResManager::~ResManager(){
    printf("ResManager.~ResManager()... \n");
    	
	_clear(UIImage *,		images)
	_clear(Properties *,		properties)
	
    printf("done\n");       
}
