#include <SDL.h>
#include <SDL_opengl.h>
#include <list>
#include "ResourceManager/resManager.h"
#include "Eventhandler.h"
#include "Gamestate.h"

#include "global.h"
#include "Map.h"
#include "GameObject.h"
#include "GameObjectList.h"
#include "GamestateStartup.h"

#include "Light.h"
#include "Ghost.h"
#include "Spikes.h"



//---------------------------------------------------------------------------------------------------
Spikes :: Spikes(float nx, float ny) : GameObject(nx-25, ny-5, resmanager->getProperties("data/objects/spikes.xml"), OBJ_SPIKES)
{
	imgSpikes			= resmanager->getImage("data/images/spikes/spikes.png");

	this->collidesWithMap			= false;
	this->affectedByGravitation		= false;
}


void Spikes :: think(){
}


void Spikes :: draw(){
	glBlendFunc(GL_DST_COLOR, GL_SRC_ALPHA);
	imgSpikes->draw(x, y);
	imgSpikes->draw(x, y);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);	//the eyecandy is drawn as ususal
}