/* Turska UI library
 * Copyright 2003-2004 Jetro Lauha
 * All rights reserved.
 * Web: http://iki.fi/jetro/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of EITHER:
 *   (1) The GNU Lesser General Public License as published by the Free
 *       Software Foundation; either version 2.1 of the License, or (at
 *       your option) any later version. The text of the GNU Lesser
 *       General Public License is included with this library in the
 *       file LICENSE-LGPL.txt.
 *   (2) The BSD-style license that is included with this library in
 *       the file LICENSE-BSD.txt.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the files
 * LICENSE-LGPL.txt and LICENSE-BSD.txt for more details.
 *
 * $Id: UIFontOpenGLSDL.h,v 1.1 2004/08/24 21:54:12 tonic Exp $
 * $Revision: 1.1 $
 */

#ifndef UIFONTOPENGLSDL_H_INCLUDED
#define UIFONTOPENGLSDL_H_INCLUDED


//! \todo Brief comment.
/*! \todo Implementation documentation with explanation of font image contents.
 */
class UIFontOpenGLSDL : public UIFont
{
public:

    //! Constructs a new font object.
    /*! The alphaTraceMinAlpha parameter is minimum alpha value to be traced
     *  as a visible pixel. It is ignored if the image surface lacks alpha.
     */
    UIFontOpenGLSDL(UIGraphicsOpenGLSDL *graphics, const char *fileName, const char *fontString = NULL,
                    UINT8 alphaTraceMinAlpha = 16);
    virtual ~UIFontOpenGLSDL();

    virtual BOOL init();

    virtual BOOL reload();

    virtual INT32 getStringWidth(const char *string);

    virtual void drawString(FLOAT x, FLOAT y, UINT32 flags, const char *string,
                            FLOAT red = 1, FLOAT green = 1, FLOAT blue = 1, FLOAT alpha = 1);

    virtual void drawString(FLOAT x, FLOAT y, UINT32 flags, const char *string, const FLOAT *color);

protected:

    UIGraphicsOpenGLSDL *mGraphics;

    UINT8 mAlphaTraceMinAlpha;
};


#endif // !UIFONTOPENGLSDL_H_INCLUDED
