

#include <string.h>
#include <map>

#include "tinyxml/tinyxml.h"

#include "Properties.h"

const char * Properties :: valueOf(const std::string &key){
	std::map<std::string, std::string> :: iterator iter = properties.find(key);
    
    if(iter != properties.end()){
		return iter->second.c_str();
    }    
    else{
        printf("can't find Propertie key: '%s'\n", key.c_str());
        return NULL;
    }
}


Properties::Properties(const std::string &filename){
	printf("loading Properties %s... ", filename.c_str());

	TiXmlDocument doc(filename);
	if(!doc.LoadFile()){
		printf("Error while loading Properties file \"%s\": %s\n", filename.c_str(), doc.ErrorDesc());
        delete this;
	}

	TiXmlElement *root = doc.RootElement();

	for(TiXmlElement* propertie = root->FirstChildElement("propertie"); propertie; propertie = propertie->NextSiblingElement("propertie") ){
		properties[propertie->Attribute("name")] = propertie->Attribute("value");
	}
	
	printf("done\n");
}
